from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Int, Boolean

Openswathdecoygenerator_V0_1_0 = CommandToolBuilder(tool="OpenSwathDecoyGenerator", base_command=["OpenSwathDecoyGenerator"], inputs=[ToolInput(tag="in_in", input_type=File(optional=True), prefix="-in", doc=InputDocumentation(doc="*             Input file (valid formats: 'tsv', 'mrm', 'pqp', 'TraML')")), ToolInput(tag="in_in_type", input_type=File(optional=True), prefix="-in_type", doc=InputDocumentation(doc="Input file type -- default: determined from file extension or content\n(valid: 'tsv', 'mrm', 'pqp', 'TraML')")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="-out", doc=InputDocumentation(doc="*            Output file (valid formats: 'tsv', 'pqp', 'TraML')")), ToolInput(tag="in_out_type", input_type=File(optional=True), prefix="-out_type", doc=InputDocumentation(doc="Output file type -- default: determined from file extension or content\n(valid: 'tsv', 'pqp', 'TraML')")), ToolInput(tag="in_method", input_type=String(optional=True), prefix="-method", doc=InputDocumentation(doc="Decoy generation method ('shuffle','pseudo-reverse','reverse','shift') (default: 'shuffle' valid: 'shuffle', 'pseudo-reverse', 'reverse', 'shift')")), ToolInput(tag="in_decoy_tag", input_type=String(optional=True), prefix="-decoy_tag", doc=InputDocumentation(doc="Decoy tag (default: 'DECOY_')")), ToolInput(tag="in_switch_kr", input_type=String(optional=True), prefix="-switchKR", doc=InputDocumentation(doc="Whether to switch terminal K and R (to achieve different precursor mass) (default: 'true' valid: 'true', 'false')")), ToolInput(tag="in_ini", input_type=File(optional=True), prefix="-ini", doc=InputDocumentation(doc="Use the given TOPP INI file")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="-threads", doc=InputDocumentation(doc="Sets the number of threads allowed to be used by the TOPP tool (default: '1')")), ToolInput(tag="in_write_ini", input_type=File(optional=True), prefix="-write_ini", doc=InputDocumentation(doc="Writes the default configuration file")), ToolInput(tag="in_helphelp", input_type=Boolean(optional=True), prefix="--helphelp", doc=InputDocumentation(doc="Shows all options (including advanced)"))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="*            Output file (valid formats: 'tsv', 'pqp', 'TraML')")), ToolOutput(tag="out_out_type", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_type", type_hint=File()), doc=OutputDocumentation(doc="Output file type -- default: determined from file extension or content\n(valid: 'tsv', 'pqp', 'TraML')"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Openswathdecoygenerator_V0_1_0().translate("wdl", allow_empty_container=True)

